- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# FCDEType Class Reference

A COLLADA typed extra node. More...

`#include <FCDExtra.h>`

Inheritance diagram for FCDEType:

List of all members.

## Public Member Functions
| FCDEType (FCDocument *document, FCDExtra *parent, const char *type)
| Constructor: do not use directly.
virtual | ~FCDEType ()
| Destructor.
FCDExtra * | GetParent ()
| Retrieves the extra tree that contains this typed extra.
const FCDExtra * | GetParent () const
| See above.
const fm::string & | GetName () const
| Retrieves the name of the type of the typed extra.
void | SetName (const fm::string &_name)
| Modifies the name of the type of the typed extra.
| DEPRECATED (3.05A, GetTechniqueCount and GetTechnique(index)) inline void GetTechniques() const
| Retrieves the list of techniques contained by this extra tree.
size_t | GetTechniqueCount () const
| Retrieves the number of techniques contained by this extra tree.
FCDETechnique * | GetTechnique (size_t index)
| Retrieves a specific technique contained by this extra tree.
const FCDETechnique * | GetTechnique (size_t index) const
| See above.
FCDETechnique * | AddTechnique (const char *profile)
| Adds a new application-specific profile technique to the extra tree.
FCDETechnique * | AddTechnique (const fm::string &profile)
| See above.
FCDETechnique * | FindTechnique (const char *profile)
| Retrieves a specific technique contained by this extra tree.
const FCDETechnique * | FindTechnique (const char *profile) const
| See above.
FCDETechnique * | FindTechnique (const fm::string &profile)
| See above.
const FCDETechnique * | FindTechnique (const fm::string &profile) const
| See above.
FCDENode * | FindRootNode (const char *name)
| Retrieves the extra tree node that has a given element name.
const FCDENode * | FindRootNode (const char *name) const
| See above.
FCDENode * | FindRootNode (const fm::string &name)
| See above.
const FCDENode * | FindRootNode (const fm::string &name) const
| See above.
FCDEType * | Clone (FCDEType *clone=NULL) const
| [INTERNAL] Clones the extra tree information.

## Detailed Description

A COLLADA typed extra node.

The 'type' attribute of the extra nodes allow us to bucket techniques to allow for different data for the same idea.

Therefore, a typed extra node contains a type name and a list of techniques.

## Constructor & Destructor Documentation

FCDEType::FCDEType | ( | FCDocument * | document,
|  | FCDExtra * | parent,
|  | const char * | type
| ) |

  | Constructor: do not use directly. Use the FCDExtra::AddType function instead. Parameters:
  | document | The COLLADA document that owns the extra tree.
  | parent | The parent extra tree structure.
  | type | The name of the type for this typed extra.

## Member Function Documentation

FCDETechnique* FCDEType::AddTechnique | ( | const char * | profile | ) |

  | Adds a new application-specific profile technique to the extra tree. If the given application-specific profile already exists within the extra tree, the old technique will be returned. Parameters:
  | profile | The application-specific profile name.
Returns: A technique for this application-specific profile.

FCDEType* FCDEType::Clone | ( | FCDEType * | clone = `NULL` | ) | const

  | [INTERNAL] Clones the extra tree information. Parameters:
  | clone | The extra tree that will take in this extra tree's information. If this pointer is NULL, a new extra tree will be created and you will need to release the returned pointer manually.
Returns: The clone.

FCDEType::DEPRECATED | ( | 3. | 05A,
|  | GetTechniqueCount and | GetTechnique(index)
| ) | const`[inline]`

| Retrieves the list of techniques contained by this extra tree. Returns: The list of techniques.

FCDENode* FCDEType::FindRootNode | ( | const char * | name | ) | `[inline]`

  | Retrieves the extra tree node that has a given element name. This function searches for the extra tree node within all the techniques. Parameters:
  | name | An element name.
Returns: The extra tree node that matches the element name. This pointer will be NULL if no extra tree node matches the element name.

FCDETechnique* FCDEType::FindTechnique | ( | const char * | profile | ) | `[inline]`

  | Retrieves a specific technique contained by this extra tree. Parameters:
  | profile | The application-specific profile name of the technique.
Returns: The technique that matches the profile name. This pointer may be NULL if no technique matches the profile name.

const fm::string& FCDEType::GetName | ( |  | ) | const`[inline]`

| Retrieves the name of the type of the typed extra. Returns: The name of the type.

FCDExtra* FCDEType::GetParent | ( |  | ) | `[inline]`

| Retrieves the extra tree that contains this typed extra. Returns: The parent extra tree.

FCDETechnique* FCDEType::GetTechnique | ( | size_t | index | ) | `[inline]`

  | Retrieves a specific technique contained by this extra tree. Parameters:
  | index | The index of the technique.
Returns: The technique. This pointer will be NULL if the index is out-of-bounds.

size_t FCDEType::GetTechniqueCount | ( |  | ) | const`[inline]`

| Retrieves the number of techniques contained by this extra tree. Returns: The number of techniques.

void FCDEType::SetName | ( | const fm::string & | _name | ) | `[inline]`

  | Modifies the name of the type of the typed extra. Be careful when modifying the name of a type. The extra tree assumes no duplicate type names within its typed extras. Parameters:
  | _name | The new name of the type.

The documentation for this class was generated from the following file:

- FCDocument/FCDExtra.h